Description

I'm going to be adding a bunch of changes to Redmine this week in order to make Enumerations more flexible and customizable.  My

specific goal is to have the Time Entry Activities flexible and when combined with a soon to be released plugin, allow Redmine to

track things like Billable and Non Billable time automatically (optional).

The short list of changes include:

Allowing custom fields on Enumerations. - Example: Is this activity billable?

Allow Time Entry Activities to be marked active or inactive.  Inactive ones will only be listed in admin pages.

Allow each project to override the Time Entry Activities' custom data - Example: ActivityA is billable except on ProjectB where it

is non-billable

Allow each project to override if each Time Entry Activity is active or inactive.  This will let a project Manager turn off activities

that aren't needed on a project.

Allow the Time Report to use the Custom Data fields as filters

All of this code has been developed and tested already and has running in production for over 4 months now.  I'm just going to

extract it from a running system so everyone can use it.  There might be some bugs from the merge and I'm sure we will need to

iterate over it a few times to make it more robust but I'd rather get this out there and get feedback on it sooner than later.

Related issues:

Related to Redmine - Defect #4084: Cannot disable activity in project when ac... Closed 2009-10-22

Related to Redmine - Defect #6564: Remove IssuePriorityCustomFields? Closed 2010-10-04

Associated revisions

Revision 2945 - 2009-10-22 00:34 - Eric Davis

Enumerations can now have custom fields defined on them. #4077

Revision 2946 - 2009-10-22 00:34 - Eric Davis

Added an active field track if an Enumeration is active on the frontend view.

Changed TimelogHelper#activity_collection_for_select_options to only use

active TimeEntryActivities.

Changed TimelogHelper#activity_collection_for_select_options to return a blank

option if the time_entry's current activity is inactive.   

#4077

Revision 2947 - 2009-10-22 00:34 - Eric Davis

Added project specific Enumeration overrides.

These will be used to track if Enumeration's custom data or active state

is overridden on a project.  An overridden Enumeration is one that is associated

with a parent Enumeration.

#4077

Revision 2948 - 2009-10-22 00:34 - Eric Davis

Changed the Timelogs to use both the Systemwide and Project specific TimeEntryActivities
Added Project#activities to return all the Systemwide and Project specific

activities, excluding Systemwide ones that are overridden.

Added some tests for TimelogHelper.   

#4077

Revision 2949 - 2009-10-22 00:34 - Eric Davis

Added a Activities tab to Project Settings

Changed Project#activities to allow getting inactive Activities also:   * Changed the Enumeration#all named_scope to exclude project specific

Activities   * Changed the Project has_many time_entry_activities to include all by default

and provided an #active method to filter them to active ones only   * Split Project#activities to two methods and gave it a parameter that is used

to determine if inactive activities are included (default is no)

Added a reset button to delete all project specific activities.

Added ProjectsController#reset_activities to remove the project

specific activities

Added a HTTP DELETE route for reset_activities

Changed the permissions for managing project activities to have access to the

ProjectsController#reset_activities action

Added a way to bulk save Project specific Activities in ProjectsController   * #save_activities will save all the changed activities, including update

the

existing records   * Added helper methods to the controller which will be refactored later   * Allow the same TimeEntryActivity names on different

projects   

#4077

Revision 2950 - 2009-10-22 00:34 - Eric Davis

When a specific TimeEntryActivity are change, associated TimeEntries will be

re-assigned to the correct record.

Renamed build to create since the methods now create objects.

Removed call to Project#save that isn't needed since objects are saved directly now.

Wrapped the activity creation and updates in a SQL transaction so TimeEntries

will remain in a consistent state if there is an error.

When a Project's TimeEntryActivities are destroyed, they are now

reassigned to the parent TimeEntryActivity.   

#4077

Revision 2951 - 2009-10-22 00:34 - Eric Davis

Added all list and boolean custom data fields to the Time Report. #4077

Revision 2952 - 2009-10-22 00:35 - Eric Davis

Fixed some merge bugs. #4077

History

#1 - 2009-10-22 00:42 - Eric Davis

- Status changed from 7 to Closed

- % Done changed from 0 to 100

This went a lot faster than I thought.  I was able to extract and merge all of the new features today (thanks git!).  I've attached some screenshots with

purple highlights to show what parts of Redmine's UI have changed.  If there are any bugs or change requests, please open a new issue and assign it

to me.

I combined the changes into 9 separate commits so they are easier to review.  Committed in: r2944, r2945, r2946, r2947, r2948, r2949, r2950, r2951, 

r2952

#2 - 2009-10-22 01:01 - Eric Davis

- File editing-a-time-entry-activity.png added

- File entering-a-time-entry.png added

- File enumeration-custom-fields.png added
- File enumeration-list.png added

- File new-project-settings-tab.png added

I guess the screenshots would be easier to see if they were attached.

Files

editing-a-time-entry-activity.png 24.1 KB 2009-10-21 Eric Davis
